## docker-runc 1.0.0~rc2+git+docker1.13.1~ds1

=== Makefile ===
.PHONY: dbuild man \
	    localtest localunittest localintegration \
	    test unittest integration

PREFIX := $(DESTDIR)/usr/local
BINDIR := $(PREFIX)/sbin
GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
RUNC_IMAGE := runc_dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
PROJECT := github.com/opencontainers/runc
TEST_DOCKERFILE := script/test_Dockerfile
BUILDTAGS := seccomp
COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
COMMIT := $(if $(shell git status --porcelain --untracked-files=no),"${COMMIT_NO}-dirty","${COMMIT_NO}")
RUNC_LINK := $(CURDIR)/Godeps/_workspace/src/github.com/opencontainers/runc
export GOPATH := $(CURDIR)/Godeps/_workspace

MAN_DIR := $(CURDIR)/man/man8
MAN_PAGES = $(shell ls $(MAN_DIR)/*.8)
MAN_PAGES_BASE = $(notdir $(MAN_PAGES))
MAN_INSTALL_PATH := ${PREFIX}/share/man/man8/

RELEASE_DIR := $(CURDIR)/release

VERSION := ${shell cat ./VERSION}

SHELL := $(shell command -v bash 2>/dev/null)

all: $(RUNC_LINK)
	go build -i -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -tags "$(BUILDTAGS)" -o runc .

static: $(RUNC_LINK)
	CGO_ENABLED=1 go build -i -tags "$(BUILDTAGS) cgo static_build" -ldflags "-w -extldflags -static -X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -o runc .

release: $(RUNC_LINK)
	@flag_list=(seccomp selinux apparmor static ambient); \
	unset expression; \
	for flag in "$${flag_list[@]}"; do \
		expression+="' '{'',$${flag}}"; \
	done; \
	eval profile_list=("$$expression"); \
	for profile in "$${profile_list[@]}"; do \
		output=${RELEASE_DIR}/runc; \
		for flag in $$profile; do \
			output+=."$$flag"; \
		done; \
		tags="$$profile"; \
		ldflags="-X main.gitCommit=${COMMIT} -X main.version=${VERSION}"; \
		CGO_ENABLED=; \
		[[ "$$profile" =~ static ]] && { \
			tags="$${tags/static/static_build}"; \
			tags+=" cgo"; \
			ldflags+=" -w -extldflags -static"; \
			CGO_ENABLED=1; \
		}; \
		echo "Building target: $$output"; \
		rm -rf "${GOPATH}/pkg"; \
		go build -i -ldflags "$$ldflags" -tags "$$tags" -o "$$output" .; \
	done

$(RUNC_LINK):
	ln -sfn $(CURDIR) $(RUNC_LINK)

dbuild: runcimage
	docker run --rm -v $(CURDIR):/go/src/$(PROJECT) --privileged $(RUNC_IMAGE) make

lint:
	go vet ./...
	go fmt ./...

man:
	man/md2man-all.sh

runcimage:
	docker build -t $(RUNC_IMAGE) .

test:
	make unittest integration

localtest:
	make localunittest localintegration

unittest: runcimage
	docker run -e TESTFLAGS -ti --privileged --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localunittest

localunittest: all
	go test -timeout 3m -tags "$(BUILDTAGS)" ${TESTFLAGS} -v ./...

integration: runcimage
	docker run -e TESTFLAGS -t --privileged --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localintegration

localintegration: all
	bats -t tests/integration${TESTFLAGS}

install:
	install -D -m0755 runc $(BINDIR)/runc

install-bash:
	install -D -m0644 contrib/completions/bash/runc $(PREFIX)/share/bash-completion/completions/runc

install-man:
	install -d -m 755 $(MAN_INSTALL_PATH)
	install -m 644 $(MAN_PAGES) $(MAN_INSTALL_PATH)

uninstall:
	rm -f $(BINDIR)/runc

uninstall-bash:
	rm -f $(PREFIX)/share/bash-completion/completions/runc

uninstall-man:
	rm -f $(addprefix $(MAN_INSTALL_PATH),$(MAN_PAGES_BASE))

clean:
	rm -f runc
	rm -f $(RUNC_LINK)
	rm -rf $(GOPATH)/pkg
	rm -rf $(RELEASE_DIR)

validate:
	script/validate-gofmt
	go vet ./...

ci: validate localtest

=== debian/changelog ===
docker-runc (1.0.0~rc2+git+docker1.13.1~ds1-3) unstable; urgency=medium

  [ Tianon Gravi ]
  * Team upload.  
  * Remove unused/unnecessary lintian-overrides
  * Update Standards-Version to 4.1.1 (no changes)
  * Add DEP3 metadata to "libcontainer-cgroup2-bugfix.patch"

  [ Michael Stapelberg ]
  * Set XS-Go-Import-Path

 -- Michael Stapelberg <stapelberg@debian.org>  Sat, 10 Feb 2018 10:42:20 +0100

docker-runc (1.0.0~rc2+git+docker1.13.1~ds1-2) unstable; urgency=medium

  * Fix Maintainer to still use the old Alioth list (thanks olasd)
    - https://lists.debian.org/debian-devel/2017/09/msg00272.html

 -- Tianon Gravi <tianon@debian.org>  Tue, 10 Oct 2017 17:10:07 -0700

docker-runc (1.0.0~rc2+git+docker1.13.1~ds1-1) unstable; urgency=medium

  * Update Maintainer to the Docker Team
  * Apply wrap-and-sort
  * Fix minor typo in Description
  * Update package version to reflect Docker version dependance (also enables
    uscan to fetch the exact proper bits)
  * Refactor to keep the vendored runtime-spec rather than using multiorig
  * Add Provides to -dev package

 -- Tianon Gravi <tianon@debian.org>  Tue, 10 Oct 2017 16:13:56 -0700

docker-runc (1.0.0~rc2+git20170201.133.9df8b30-4) unstable; urgency=medium

  * Team Upload.
  * Update watch file to match release candidates
  * Fix typo in golang-github-opencontainers-runc-dev package description
    (Closes: #873760)
  * Rename source package to docker-runc and binary packages accordingly
    (Closes: #877284)
  * Build-depend on rename
  * Rename runc binary to docker-runc matching docker.io upstream's practice
  * Use the docker-runc name in the man pages
  * Build-depend on golang-github-xeipuuv-gojsonschema-dev
  * Add runtime-spec as additional upstream tarball using Debian's
    golang-github-opencontainers-specs 1.0.0~rc2+git20160926.38.1c7c27d
    original tarball instead of build-depending on
    golang-github-opencontainers-specs-dev which package has incompatible
    changes following upstream.

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 30 Sep 2017 00:35:47 -0400

runc (1.0.0~rc2+git20170201.133.9df8b30-3) unstable; urgency=medium

  * Replace golang-go with golang-any in Build-Depends

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 09 Aug 2017 15:00:55 +0300

runc (1.0.0~rc2+git20170201.133.9df8b30-2) unstable; urgency=medium

  * Patch to make libcontainer ignore cgroup2 hierarchy. Patch pulled from
    https://github.com/opencontainers/runc/pull/1266.

 -- Vincent Bernat <bernat@debian.org>  Fri, 30 Jun 2017 07:10:34 +0200

runc (1.0.0~rc2+git20170201.133.9df8b30-1) unstable; urgency=medium

  * New upstream snapshot for Docker 1.13.1.

 -- Tim Potter <tpot@hpe.com>  Wed, 24 May 2017 11:36:40 +1000

runc (1.0.0~rc2+git20161109.131.5137186-2) unstable; urgency=medium

  * Add Breaks line to binary package to avoid messing up previous 
    Docker installs.

 -- Tim Potter <tpot@hpe.com>  Fri, 24 Feb 2017 09:49:06 +1100

runc (1.0.0~rc2+git20161109.131.5137186-1) unstable; urgency=medium

  * New upstream snapshot.
  * Refresh backported patch for CVE-2016-9962.

 -- Tim Potter <tpot@hpe.com>  Wed, 15 Feb 2017 09:08:52 +1100

runc (0.1.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Backport patch for CVE-2016-9962 (Closes: #850951)

 -- Tianon Gravi <tianon@debian.org>  Wed, 01 Feb 2017 07:17:54 -0800

runc (0.1.1+dfsg1-1) unstable; urgency=medium

  * New upstream release [June 2016].
  * testworks: disabled privileged and failing tests.
  * Build with "apparmor seccomp" tags (Closes: #830818);
    Build-Depends += "libapparmor-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 13 Jul 2016 23:00:43 +1000

runc (0.1.0+dfsg1-1) unstable; urgency=medium

  * Dropped dependency on "golang-docker-dev" in favour of bundled
    (or build time sub-vendored) "github.com/docker/docker" in order
    to avoid circular dependency with Docker.
  * Standards-Version: 3.9.8.
  * Corrected Vcs-Git URL.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 12 Jun 2016 17:56:45 +1000

runc (0.1.0+dfsg-1) unstable; urgency=medium

  [ Tim Potter ]
  * Team upload
  * New upstream release [April 2016]
    = golang-github-opencontainers-specs-dev (>= 0.5.0~)
  * De-vendor new dependencies; pquerna/ffjson appears unused

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 23 Apr 2016 07:59:18 +1000

runc (0.0.9+dfsg-1) unstable; urgency=medium

  * New upstream release [March 2016].
  * (Build-)Depends:
    = golang-github-opencontainers-specs-dev (>= 0.4.0~)
    = golang-github-codegangsta-cli-dev (>= 0.0~git20151221~)
    - help2man
    + go-md2man
  * Install upstream man pages.
  * Install "runc" binary to "/usr/sbin".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 16 Apr 2016 17:23:48 +1000

runc (0.0.8+dfsg-2) unstable; urgency=medium

  * (Build-)Depends:
    + golang-github-docker-go-units-dev
    + golang-github-seccomp-libseccomp-golang-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 23 Mar 2016 20:05:01 +1100

runc (0.0.8+dfsg-1) unstable; urgency=medium

  * New upstream release [February 2016].
  * Build-Depends:
    + golang-github-vishvananda-netlink-dev
  * Updated Vcs URLs.
  * Standards-Version: 3.9.7.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 26 Feb 2016 18:19:24 +1100

runc (0.0.4~dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #802507).
  * Dropped obsolete lintian-overrides.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 21 Oct 2015 09:02:42 +1100

runc (0.0.3~dfsg2-1) unstable; urgency=low

  * Initial release (Closes: #796486).
    Thanks, Alexandre Viau.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 06 Sep 2015 18:06:34 +1000

=== debian/control ===
Source: docker-runc
Section: devel
Priority: extra
Maintainer: Docker Packaging Team <docker-maint@lists.alioth.debian.org>
Uploaders: Tim Potter <tpot@debian.org>, Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 9),
               dh-exec,
               dh-golang,
               go-md2man,
               golang-any,
               golang-dbus-dev,
               golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
               golang-github-coreos-go-systemd-dev,
               golang-github-docker-go-units-dev,
               golang-github-mrunalp-fileutils-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-xeipuuv-gojsonschema-dev,
               golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
               golang-goprotobuf-dev,
               golang-logrus-dev,
               libapparmor-dev,
               protobuf-compiler,
               rename
Standards-Version: 4.1.1
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://anonscm.debian.org/git/docker/docker-runc.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker-runc.git
XS-Go-Import-Path: github.com/opencontainers/runc

Package: docker-runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 1.12)
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime (Docker's version)
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package contains the version to be used with docker.io packages and
 provides "runc" as the "docker-runc" executable binary.

Package: golang-github-opencontainers-docker-runc-dev
Architecture: all
Depends: golang-dbus-dev,
         golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
         golang-github-coreos-go-systemd-dev,
         golang-github-docker-go-units-dev,
         golang-github-seccomp-libseccomp-golang-dev,
         golang-github-vishvananda-netlink-dev,
         golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
         golang-goprotobuf-dev,
         golang-logrus-dev,
         ${misc:Depends}
Provides: golang-github-opencontainers-runc-dev
Conflicts: golang-github-opencontainers-runc-dev
Description: Open Container Project - development files (Docker's version)
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".
 .
 This package contains the version to be used with docker.io packages.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOPKG := github.com/opencontainers/runc
export DH_GOLANG_INSTALL_EXTRA := libcontainer/seccomp/fixtures
export DH_GOLANG_EXCLUDES := libcontainer/integration

TAGS := apparmor seccomp

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`

override_dh_auto_configure:
	$(MAKE) -C libcontainer/criurpc
	cd man && ./md2man-all.sh
	rename 's/runc/docker-runc/' man/man8/*.8
	dh_auto_configure
	## Sub-vendor intentionally-vendored deps:
	set -ex; for pkg in \
		github.com/docker/docker/pkg \
		github.com/opencontainers/runtime-spec \
	; do \
		[ -d "Godeps/_workspace/src/$$pkg" ]; \
		mkdir -p "_build/src/$(DH_GOPKG)/vendor/$$pkg"; \
		parentDir="$$(dirname "_build/src/$(DH_GOPKG)/vendor/$$pkg")"; \
		cp -vr "Godeps/_workspace/src/$$pkg" "$$parentDir"; \
	done

override_dh_auto_build:
	dh_auto_build -- -tags '$(TAGS)'

override_dh_auto_test:
	-dh_auto_test -- -tags '$(TAGS)' -test.short

=== debian/watch ===
version=4

opts=\
dversionmangle=s/[+~](debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/^/1.0.0~rc2+git+docker/;s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
repacksuffix=~ds1 \
  https://uscan.tianon.xyz/github.com/tianon/docker-runc-tags \
  https://github.com/.*/docker-(\d\S*)\.tar\.gz
